import bb.cascades 1.3
import bb.system 1.2

ActionItem {
    title: qsTr("Change Password") + Retranslate.onLanguageChanged
    ActionBar.placement: ActionBarPlacement.Signature
    imageSource: "asset:///images/ic_copy_password.png"
    onTriggered: { changePasswordPrompt.show() }
    attachedObjects: [
        SystemPrompt {
            id: changePasswordPrompt
            title: qsTr("Enter password") + Retranslate.onLanguageChanged
            body: qsTr("To change Password, you need to enter the old Password.") + Retranslate.onLanguageChanged
            inputField.inputMode: SystemUiInputMode.Password
            onFinished: {
                if (inputFieldTextEntry() == _settings.value("password", "CellNinja")) {
                    setPasswordPrompt.show()
                }
                else {
                    errorToast.show()
                }
            }
        },
        SystemToast {
            id: errorToast
            body: qsTr("Wrong Password") + Retranslate.onLanguageChanged
            button.label: qsTr("Ok") + Retranslate.onLanguageChanged
        }
    ]
}