import bb.cascades 1.3

MultiCover {
    SceneCover {
        id: bigCover
        MultiCover.level: CoverDetailLevel.High
        
        content: Container {
            id: bigCoverContainer
            background: mainPage.blockBackgroundColor
            layout: DockLayout {}
            horizontalAlignment: HorizontalAlignment.Fill
            verticalAlignment: VerticalAlignment.Fill
            leftPadding: ui.du(2)
            rightPadding: leftPadding
            topPadding: leftPadding
            bottomPadding: leftPadding
            ImageView {
                id: bigCoverImageView
                imageSource: "asset:///images/PM_active_frame.png"
                scalingMethod: ScalingMethod.AspectFit
                preferredHeight: _app.deviceInfo.activeFrameHeight
                horizontalAlignment: HorizontalAlignment.Center
                verticalAlignment: VerticalAlignment.Center
            }
        }
    } // sceneCover HIGH
    
    SceneCover {
        id: smallCover
        MultiCover.level: CoverDetailLevel.Medium
        
        content: Container {
            background: bigCoverContainer.background
            layout: DockLayout {}
            horizontalAlignment: HorizontalAlignment.Fill
            verticalAlignment: VerticalAlignment.Fill
            leftPadding: ui.du(2)
            rightPadding: leftPadding
            topPadding: leftPadding
            bottomPadding: leftPadding
            ImageView {
                imageSource: bigCoverImageView.imageSource
                scalingMethod: ScalingMethod.AspectFit
                horizontalAlignment: HorizontalAlignment.Center
                verticalAlignment: VerticalAlignment.Center
            }
        }
    } // sceneCover MEDIUM
}
