import bb.cascades 1.3

Container {
    property string appName
    property string bbwLink
    property string appDescription
    
    leftMargin: ui.du(3)
    rightMargin: leftMargin
    topMargin: leftMargin
    
    minWidth: ui.du(40)
    maxWidth: minWidth
    
    attachedObjects: [
        Invocation{
            id: appWorldInvoke
            query {
                invokeActionId: "bb.action.OPEN"
                invokeTargetId: "sys.appworld"
            }
            onArmed: {
                trigger(query.invokeActionId)
            }
        }
    ]

    gestureHandlers: [
        TapHandler {
            onTapped: {
                appWorldInvoke.query.setUri(bbwLink)
                appWorldInvoke.query.updateQuery()
            }
        }
    ]
    
    ImageView {
        id: imageView
        imageSource: "asset:///images/PartnerApps/" + appName + ".png"
        minHeight: parent.minWidth / 2
        maxHeight: minHeight
        minWidth: minHeight
        maxWidth: minHeight
        scalingMethod: ScalingMethod.AspectFit
        horizontalAlignment: HorizontalAlignment.Center
        verticalAlignment: VerticalAlignment.Center
    }
    Label {
        text: appName
        multiline: true
        textStyle.textAlign: TextAlign.Center
        textStyle.fontSize: FontSize.XLarge
        horizontalAlignment: HorizontalAlignment.Center
        verticalAlignment: VerticalAlignment.Center
    }
    Label {
        text: appDescription
        multiline: true
        textStyle.textAlign: TextAlign.Center
        textStyle.fontSize: FontSize.Small
        horizontalAlignment: HorizontalAlignment.Center
        verticalAlignment: VerticalAlignment.Center
    }
}
