import bb.cascades 1.3

Container {
    topMargin: ui.du(1)
    bottomMargin: topMargin
    Label {
        text: qsTr("Default Email Account") + Retranslate.onLanguageChanged
        textStyle.base: headingStyle.style
        multiline: true
    }
    Label {
        text: qsTr("When not specified, use this default email account to send GPS infos.") + Retranslate.onLanguageChanged
        multiline: true
    }
    DropDown {
        id: dropDown
        title: qsTr("Default Sender Email Account") + Retranslate.onLanguageChanged
        onSelectedOptionChanged: { _settings.setValue("defaultSenderEmailAccount", Number(selectedValue).toFixed(0)) }
        onCreationCompleted: { _app.emailAccountsFound.connect(onEmailAccountsFound) }

        function onEmailAccountsFound(emailAccounts) {
            for (var i = 0; i < emailAccounts.length; i++) {
                var newOption = optionFactory.createObject()
                newOption.text = emailAccounts[i].address
                newOption.value = emailAccounts[i].id
                dropDown.add(newOption);
            }
            
            var settingsValue = _settings.value("defaultSenderEmailAccount", -1)
            for (var i = 0; i < dropDown.count(); i++) {
                if (settingsValue == dropDown.at(i).value)
                    dropDown.setSelectedOption(dropDown.at(i))
            }
        }
        
        attachedObjects: [
            ComponentDefinition {
                id: optionFactory
                Option {}
            }
        ]
    }
    
    
    Container {
        topPadding: ui.du(1)
        Label {
            text: qsTr("When not specified, email GPS infos to this default address :") + Retranslate.onLanguageChanged
            multiline: true
        }
        TextField {
            text: _settings.value("defaultReceiverEmailAccount", "")
            onTextChanging: { _settings.setValue("defaultReceiverEmailAccount", text.trim()) }
            inputMode: inputMode.EmailAddress
        }
    }
}
