import bb.cascades 1.3
import bb.system 1.2

Container {
    topMargin: ui.du(1)
    bottomMargin: topMargin
    
    onCreationCompleted: {
        // Avoid having to maintain the same defaultMessage in password.qml
        if (_settings.value("lockScreenMessage", "") == "") {
            _settings.setValue("lockScreenMessage", textField.defaultMessage)
        }
    }
    
    Label {
        text: qsTr("Lock Screen Message") + Retranslate.onLanguageChanged
        textStyle.base: headingStyle.style
        multiline: true
    }
    Label {
        text: qsTr("What default message to display when asking for Password.") + Retranslate.onLanguageChanged
        multiline: true
    }
    TextField {
        id: textField
        property string defaultMessage: qsTr("This phone is lost, please contact John at home (555)555-1234") + Retranslate.onLanguageChanged
        hintText: defaultMessage
        text: _settings.value("lockScreenMessage", defaultMessage)
    }
    Button {
        text: qsTr("Save") + Retranslate.onLanguageChanged
        onClicked: {
            _settings.setValue("lockScreenMessage", textField.text)
            savedToast.show()
        }
        attachedObjects: [
            SystemToast {
                id: savedToast
                body: qsTr("Lock Screen Message saved successfully") + Retranslate.onLanguageChanged
            }
        ]
    }
}
