import bb.cascades 1.3
import bb.system 1.2
import bb.cascades.places 1.0

Container {
    topMargin: ui.du(1)
    bottomMargin: topMargin
    
    attachedObjects: [
        PlacePicker { id: picker }
    ]
    
    Label {
        text: qsTr("Safe Zone") + Retranslate.onLanguageChanged
        textStyle.base: headingStyle.style
        multiline: true
    }
    Label {
        text: qsTr("Never lock the phone when you are inside one of those locations (100 meters / 330 feet radius).\n\n** WARNING : If you set a Safe Zone while you're in the Safe Zone, you'll have to exit that Safe Zone and re-enter before it starts to work. Also, disabling GPS will prevent this feature to work. **") + Retranslate.onLanguageChanged
        multiline: true
    }
    DropDown {
        id: dropDown
        title: qsTr("Safe Zone Enabled") + Retranslate.onLanguageChanged
        Option {                        
            text: qsTr("Yes") + Retranslate.onLanguageChanged
            value: true
        }
        Option {                        
            text: qsTr("No") + Retranslate.onLanguageChanged
            value: false
        }
        onSelectedOptionChanged: { _settings.setValue("safeZoneEnabled", selectedValue) }
    }
    
    onCreationCompleted: {
        var settingsValue = _settings.value("safeZoneEnabled", true)
        for (var i = 0; i < dropDown.count(); i++) {
            if (settingsValue == dropDown.at(i).value)
                dropDown.setSelectedOption(dropDown.at(i))
        }
    }
    
    Container {
        visible: dropDown.selectedValue
        Container {
            layout: StackLayout { orientation: LayoutOrientation.LeftToRight }
            topMargin: ui.du(1)
            bottomMargin: topMargin
            Button {
                text: qsTr("Set Safe Zone #1") + Retranslate.onLanguageChanged
                verticalAlignment: VerticalAlignment.Center
                minWidth: ui.du(37)
                maxWidth: minWidth
                onClicked: {
                    var place = picker.show()
                    if (place) {
                        var safeZone = new Object()
                        safeZone.name = place.name
                        safeZone.latitude = place.latitude
                        safeZone.longitude = place.longitude
                        _settings.setValue("safeZone1", safeZone)
                        safeZone.safeZone = "safeZone1"
                        _app.addSafeZone(safeZone)
                        safeZone1Label.text = place.name
                    }
                }
            }
            Label {
                id: safeZone1Label
                text: _settings.value("safeZone1", "").name
                verticalAlignment: VerticalAlignment.Center
            }
            ImageButton {
                defaultImageSource: "asset:///images/ic_delete.png"
                minHeight: ui.du(9.6)
                minWidth: minHeight
                maxHeight: minHeight
                maxWidth: minHeight
                visible: (safeZone1Label.text != "")
                verticalAlignment: VerticalAlignment.Center
                onClicked: { 
                    _app.removeSafeZone("safeZone1")
                    _settings.setValue("safeZone1", "")
                    safeZone1Label.text = ""
                }
            }
        }
        Container {
            layout: StackLayout { orientation: LayoutOrientation.LeftToRight }
            topMargin: ui.du(1)
            bottomMargin: topMargin
            Button {
                text: qsTr("Set Safe Zone #2") + Retranslate.onLanguageChanged
                verticalAlignment: VerticalAlignment.Center
                minWidth: ui.du(37)
                maxWidth: minWidth
                onClicked: {
                    var place = picker.show()
                    if (place) {
                        var safeZone = new Object()
                        safeZone.name = place.name
                        safeZone.latitude = place.latitude
                        safeZone.longitude = place.longitude
                        _settings.setValue("safeZone2", safeZone)
                        safeZone.safeZone = "safeZone2"
                        _app.addSafeZone(safeZone)
                        //                    _app.sendToHL("NEW_SAFE_ZONE", "safeZone2," + place.latitude + "," + place.longitude)
                        safeZone2Label.text = place.name
                    }
                }
            }
            Label {
                id: safeZone2Label
                text: _settings.value("safeZone2", "").name
                verticalAlignment: VerticalAlignment.Center
            }
            ImageButton {
                defaultImageSource: "asset:///images/ic_delete.png"
                minHeight: ui.du(9.6)
                minWidth: minHeight
                maxHeight: minHeight
                maxWidth: minHeight
                visible: (safeZone2Label.text != "")
                verticalAlignment: VerticalAlignment.Center
                onClicked: { 
                    _app.removeSafeZone("safeZone2")
                    //                _app.sendToHL("DELETE_SAFE_ZONE", "safeZone2," + _settings.value("safeZone2", "").latitude + "," + _settings.value("safeZone2", "").longitude)
                    _settings.setValue("safeZone2", "")
                    safeZone2Label.text = ""
                }
            }
        }
        Container {
            layout: StackLayout { orientation: LayoutOrientation.LeftToRight }
            topMargin: ui.du(1)
            bottomMargin: topMargin
            Button {
                text: qsTr("Set Safe Zone #3") + Retranslate.onLanguageChanged
                verticalAlignment: VerticalAlignment.Center
                minWidth: ui.du(37)
                maxWidth: minWidth
                onClicked: {
                    var place = picker.show()
                    if (place) {
                        var safeZone = new Object()
                        safeZone.name = place.name
                        safeZone.latitude = place.latitude
                        safeZone.longitude = place.longitude
                        _settings.setValue("safeZone3", safeZone)
                        safeZone.safeZone = "safeZone3"
                        _app.addSafeZone(safeZone)
                        //                    _app.sendToHL("NEW_SAFE_ZONE", "safeZone3," + place.latitude + "," + place.longitude)
                        safeZone3Label.text = place.name
                    }
                }
            }
            Label {
                id: safeZone3Label
                text: _settings.value("safeZone3", "").name
                verticalAlignment: VerticalAlignment.Center
            }
            ImageButton {
                defaultImageSource: "asset:///images/ic_delete.png"
                minHeight: ui.du(9.6)
                minWidth: minHeight
                maxHeight: minHeight
                maxWidth: minHeight
                visible: (safeZone3Label.text != "")
                verticalAlignment: VerticalAlignment.Center
                onClicked: { 
                    _app.removeSafeZone("safeZone3")
                    //                _app.sendToHL("DELETE_SAFE_ZONE", "safeZone3," + _settings.value("safeZone3", "").latitude + "," + _settings.value("safeZone3", "").longitude)
                    _settings.setValue("safeZone3", "")
                    safeZone3Label.text = ""
                }
            }
        }
        Container {
            topPadding: ui.du(3)
            Label {
                text: qsTr("Hub Notification") + Retranslate.onLanguageChanged
                textStyle.base: headingStyle.style
                multiline: true
            }
            Label {
                text: qsTr("Send a Hub notification if a suspicious activity is found while in a Safe Zone. You'll know that the trigger worked, but the phone didn't lock because you are in a Safe Zone. Please note that this might also warn a thief that your device is monitored by an anti-theft app.") + Retranslate.onLanguageChanged
                multiline: true
            }
            DropDown {
                id: hubNotificationDropDown
                title: qsTr("Hub Notification Enabled") + Retranslate.onLanguageChanged
                Option {                        
                    text: qsTr("Yes") + Retranslate.onLanguageChanged
                    value: true
                }
                Option {                        
                    text: qsTr("No") + Retranslate.onLanguageChanged
                    value: false
                }
                onSelectedOptionChanged: { _settings.setValue("safeZoneHubWarningEnabled", selectedValue) }
            }
            
            onCreationCompleted: {
                var settingsValue = _settings.value("safeZoneHubWarningEnabled", false)
                for (var i = 0; i < hubNotificationDropDown.count(); i++) {
                    if (settingsValue == hubNotificationDropDown.at(i).value)
                        hubNotificationDropDown.setSelectedOption(hubNotificationDropDown.at(i))
                }
            }
        }
        Container {
            topPadding: ui.du(3)
            Label {
                text: qsTr("Lock & Unlock On Safe Zone") + Retranslate.onLanguageChanged
                textStyle.base: headingStyle.style
                multiline: true
            }
            Label {
                text: qsTr("Lock if device leaves Safe Zone and Unlock if device enters Safe Zone.") + Retranslate.onLanguageChanged
                multiline: true
            }
            DropDown {
                id: lockDropDown
                title: qsTr("Lock & Unlock On Safe Zone") + Retranslate.onLanguageChanged
                Option {                        
                    text: qsTr("Yes") + Retranslate.onLanguageChanged
                    value: true
                }
                Option {                        
                    text: qsTr("No") + Retranslate.onLanguageChanged
                    value: false
                }
                onSelectedOptionChanged: { _settings.setValue("lockOnSafeZoneExit", selectedValue) }
            }
            
            onCreationCompleted: {
                var settingsValue = _settings.value("lockOnSafeZoneExit", false)
                for (var i = 0; i < lockDropDown.count(); i++) {
                    if (settingsValue == lockDropDown.at(i).value)
                        lockDropDown.setSelectedOption(lockDropDown.at(i))
                }
            }
        }
    } // End of Container visible only if DropDown is enabled
}
