import bb.cascades 1.3
import bb.cascades.pickers 1.0
import bb.multimedia 1.2

Container {
    id: soundContainer
    topMargin: ui.du(1)
    bottomMargin: topMargin
    Label {
        text: qsTr("Sound") + Retranslate.onLanguageChanged
        textStyle.base: headingStyle.style
        multiline: true
    }
    DropDown {
        id: soundDropDown
        title: qsTr("Play sound on Bluetooth connection lost") + Retranslate.onLanguageChanged
        Option {                        
            text: qsTr("Yes") + Retranslate.onLanguageChanged
            value: true
        }
        Option {                        
            text: qsTr("No") + Retranslate.onLanguageChanged
            value: false
        }
        onSelectedOptionChanged: { _settings.setValue("playSoundOnBluetoothConnectionLost", selectedValue) }
    }
    
    onCreationCompleted: {
        var settingsValue = _settings.value("playSoundOnBluetoothConnectionLost", false)
        for (var i = 0; i < soundDropDown.count(); i++) {
            if (settingsValue == soundDropDown.at(i).value)
                soundDropDown.setSelectedOption(soundDropDown.at(i))
        }
    }
    
    Container {
        layout: StackLayout { orientation: LayoutOrientation.LeftToRight }
        visible: soundDropDown.selectedValue
        Button {
            text: qsTr("Choose Sound") + Retranslate.onLanguageChanged
            onClicked: { filePicker.open() }
            attachedObjects: [
                FilePicker {
                    id:filePicker
                    type : FileType.Music
                    title : "Select Sound"
                    directories : ["/accounts/1000/shared/music"]
                    onFileSelected : {
                        console.log("FileSelected signal received : " + selectedFiles);
                        if (selectedFiles.length > 0) {
                            _settings.setValue("soundSourceUrl", selectedFiles[0])
                            soundSourceUrlLabel.getFileName()
                        }
                    }
                }
            ]
        }
        Label {
            id: soundSourceUrlLabel
            property string soundFileName
            verticalAlignment: VerticalAlignment.Center
            onCreationCompleted: { getFileName() }
            function getFileName() {
                var urlList = String(_settings.value("soundSourceUrl", "asset:///sounds/alarm.mp3")).split("/")
                var sound = urlList[urlList.length - 1]
                text = sound
            }
        }
    }
    Button {
        text: (mediaPlayer.mediaState == MediaState.Started) ? qsTr("Stop") + Retranslate.onLanguageChanged : qsTr("Test it") + Retranslate.onLanguageChanged
        horizontalAlignment: HorizontalAlignment.Center
        visible: soundDropDown.selectedValue
        onClicked: { 
            if (mediaPlayer.mediaState == MediaState.Started) {
                mediaPlayer.stop()
            }
            else {
                mediaPlayer.setSourceUrl(_settings.value("soundSourceUrl", "asset:///sounds/alarm.mp3"))
                mediaPlayer.play()
            }
        }
        attachedObjects: [
            MediaPlayer { id: mediaPlayer }
        ]
    }

} // End of vibeContainer
