import bb.cascades 1.3
import bb.device 1.3

Container {
    attachedObjects: [
        VibrationController { id: vibrationController }
    ]
    
    Container {
        id: vibeContainer
        visible: vibrationController.isSupported()
        topMargin: ui.du(1)
        bottomMargin: topMargin
        Label {
            text: qsTr("Vibration") + Retranslate.onLanguageChanged
            textStyle.base: headingStyle.style
            multiline: true
        }
        
        DropDown {
            id: vibeDropDown
            title: qsTr("Vibe on Bluetooth connection lost") + Retranslate.onLanguageChanged
            Option {                        
                text: qsTr("Yes") + Retranslate.onLanguageChanged
                value: true
            }
            Option {                        
                text: qsTr("No") + Retranslate.onLanguageChanged
                value: false
            }
            onSelectedOptionChanged: { _settings.setValue("vibeOnBluetoothConnectionLost", selectedValue) }
        }
        
        onCreationCompleted: {
            var settingsValue = _settings.value("vibeOnBluetoothConnectionLost", false)
            for (var i = 0; i < vibeDropDown.count(); i++) {
                if (settingsValue == vibeDropDown.at(i).value)
                    vibeDropDown.setSelectedOption(vibeDropDown.at(i))
            }
        }
        
        Container {
            id: vibrationSettings
            visible: vibeDropDown.selectedValue
            Container {
                // Intensity is ignored, see https://developer.blackberry.com/native/reference/cascades/bb__device__vibrationcontroller.html#function-start-intensity-milliseconds
                visible: false
                layout: StackLayout { orientation: LayoutOrientation.LeftToRight }
                Container {
                    layoutProperties: StackLayoutProperties { spaceQuota: 1 }
                    Label { text: qsTr("Intensity:") + Retranslate.onLanguageChanged }
                }
                Container {
                    layoutProperties: StackLayoutProperties { spaceQuota: 3 }
                    Slider {
                        id: intensity
                        fromValue: 10
                        toValue: 100
                        value: _settings.value("vibeIntensity", 100)
                        onValueChanged: _settings.setValue("vibeIntensity", value.toFixed(0))
                    }
                }
            }
            Container {
                layout: StackLayout { orientation: LayoutOrientation.LeftToRight }
                Container {
                    layoutProperties: StackLayoutProperties { spaceQuota: 1 }
                    Label { text: qsTr("Duration:") + Retranslate.onLanguageChanged }
                }
                Container {
                    layoutProperties: StackLayoutProperties { spaceQuota: 3 }
                    Slider {
                        id: duration
                        fromValue: 100
                        toValue: 5000
                        value: _settings.value("vibeDuration", 1000)
                        onValueChanged: _settings.setValue("vibeDuration", value.toFixed(0))
                    }
                }
            }
            Button {
                text: qsTr("Test it") + Retranslate.onLanguageChanged
                horizontalAlignment: HorizontalAlignment.Center
                onClicked: { vibrationController.start(intensity.value, duration.value) }
            }
        } // End of vibrationSettings Container
    } // End of vibeContainer
}
