import bb.cascades 1.3
import bb.system 1.2
import "../Actions"
import "../MyApps"
import "../CustomElements"

Sheet {
    id: aboutSheet
    
    onOpened: { Application.setMenuEnabled(false) }
    onClosed: { Application.setMenuEnabled(true) }
    
    Page {
        titleBar: TitleBar {
            title: qsTr("About") + Retranslate.onLanguageChanged
            acceptAction: ActionItem {
                title: qsTr("Ok") + Retranslate.onLanguageChanged
                onTriggered: {
                    aboutSheet.close()
                }
            }
        }
        
        actions: [
            TutorialAction {},
            ReportBugAction {}
        ]
        
        ScrollView {
            Container {
                id: mainContainer
                
                layout: DockLayout {}
                horizontalAlignment: HorizontalAlignment.Fill
                verticalAlignment: VerticalAlignment.Fill
                background: mainPage.blockBackgroundColor
                leftPadding: ui.du(3)
                rightPadding: leftPadding
                topPadding: ui.du(1)
                bottomPadding: topPadding
                Container {
                    horizontalAlignment: HorizontalAlignment.Center
                    verticalAlignment: VerticalAlignment.Center
                    Label {
                        id: appNameLabel
                        horizontalAlignment: HorizontalAlignment.Center
                        text: Application.applicationName + " " + Application.applicationVersion
                        textStyle.base: SystemDefaults.TextStyles.BigText
                    }
                    Label {
                        property string emailUri: "mailto:roger@rogerleblanc.net?subject=" + appNameLabel.text + " support"
                        horizontalAlignment: HorizontalAlignment.Center
                        text: "<html><a href=\"" + emailUri + "\">" + qsTr("by CellNinja") + Retranslate.onLanguageChanged + "</a></html>"
                        multiline: true
                        textStyle.base: SystemDefaults.TextStyles.TitleText
                    }
                    PartnerApps { topPadding: ui.du(3) }
                    MyApps { topPadding: ui.du(3) }
                    Container {
                        topPadding: ui.du(3)
                        horizontalAlignment: HorizontalAlignment.Center
                        Button {
                            text: qsTr("CellNinja BBM Channel") + Retranslate.onLanguageChanged
                            imageSource: "asset:///images/ic_bbmchannel.png"
                            onClicked: { 
                                invokeChannel.query.invokeTargetId = "sys.bbm.channels.card.previewer"
                                invokeChannel.query.invokeActionId = "bb.action.OPENBBMCHANNEL"
                                invokeChannel.query.uri = "bbmc:C004E866D"
                                invokeChannel.query.updateQuery()
                            }
                            attachedObjects: [
                                Invocation {
                                    id: invokeChannel
                                    onArmed: { trigger(query.invokeActionId) }
                                }
                            ]
                        }
                    }
                    Container {
                        visible: false
                        topPadding: ui.du(3)
                        horizontalAlignment: HorizontalAlignment.Center
                        Button {
                            text: qsTr("Restart Tutorial") + Retranslate.onLanguageChanged
                            onClicked: { tutorialSheet.open() }
                        }
                    }
                }
            }
        }
    }
}