import bb.cascades 1.3

Sheet {
    id: lostPasswordSheet
    
    property bool initialized: false
    
    onOpened: { Application.setMenuEnabled(false) }
    onClosed: {
        Application.setMenuEnabled(true)
        
        if (_settings.value("showFirstTimeTutorial", true))
            tutorialSheet.open()
    }
    
    attachedObjects: [
        RenderFence {
            raised: true
            onReached: { initialized = true }
        }
    ]
    
    Page {
        titleBar: TitleBar {
            title: qsTr("Lost Password") + Retranslate.onLanguageChanged
            acceptAction: ActionItem {
                title: qsTr("Ok") + Retranslate.onLanguageChanged
                onTriggered: {
                    lostPasswordSheet.close()
                }
            }
        }
        
        ScrollView {
            Container {
                id: mainContainer
                
                background: mainPage.blockBackgroundColor
                leftPadding: ui.du(3)
                rightPadding: leftPadding
                horizontalAlignment: HorizontalAlignment.Fill
                verticalAlignment: VerticalAlignment.Fill
                
                Label {
                    text: qsTr("Lost Password Question") + Retranslate.onLanguageChanged
                    textStyle.base: headingStyle.style
                    multiline: true
                }
                Label {
                    text: qsTr("What question to ask if you lost your Password?") + Retranslate.onLanguageChanged
                    multiline: true
                }
                TextField {
                    id: questionTextField
                    property string defaultMessage: qsTr("First and last name of my oldest grandmother?") + Retranslate.onLanguageChanged
                    hintText: defaultMessage
                    text: { _settings.value("lostPasswordQuestion", defaultMessage) }
                    onTextChanging: { 
                        _settings.setValue("lostPasswordQuestion", questionTextField.text) 
                        
                        if (initialized)
                            answerTextField.text = ""
                    }
                }
                TextField {
                    id: answerTextField
                    text: { _settings.value("lostPasswordAnswer", "") }
                    onTextChanging: { _settings.setValue("lostPasswordAnswer", answerTextField.text) }
                }
            }
        }
    }
}