import bb.cascades 1.0

Container {
    id: container
    property int duration: 1000
    property string color: "ColorTheme"
    property bool isDarkTheme: false
    property bool running: true
    
    onColorChanged: {
        if (color == "ColorBabyBlue") {
            outerCircle.imageSource = "asset:///Squircle/squircleBabyBlue.png"
            innerCircle.imageSource = outerCircle.imageSource
        }
        else if (color == "ColorBlack") {
            outerCircle.imageSource = "asset:///Squircle/squircleBlack.png"
            innerCircle.imageSource = outerCircle.imageSource
        }
        else if (color == "ColorBlue") {
            outerCircle.imageSource = "asset:///Squircle/squircleBlue.png"
            innerCircle.imageSource = outerCircle.imageSource
        }
        else if (color == "ColorGray") {
            outerCircle.imageSource = "asset:///Squircle/squircleGray.png"
            innerCircle.imageSource = outerCircle.imageSource
        }
        else if (color == "ColorGreen") {
            outerCircle.imageSource = "asset:///Squircle/squircleGreen.png"
            innerCircle.imageSource = outerCircle.imageSource
        }
        else if (color == "ColorOrange") {
            outerCircle.imageSource = "asset:///Squircle/squircleOrange.png"
            innerCircle.imageSource = outerCircle.imageSource
        }
        else if (color == "ColorPink") {
            outerCircle.imageSource = "asset:///Squircle/squirclePink.png"
            innerCircle.imageSource = outerCircle.imageSource
        }
        else if (color == "ColorPurple") {
            outerCircle.imageSource = "asset:///Squircle/squirclePurple.png"
            innerCircle.imageSource = outerCircle.imageSource
        }
        else if (color == "ColorRed") {
            outerCircle.imageSource = "asset:///Squircle/squircleRed.png"
            innerCircle.imageSource = outerCircle.imageSource
        }
        else if (color == "ColorWhite") {
            outerCircle.imageSource = "asset:///Squircle/squircleWhite.png"
            innerCircle.imageSource = outerCircle.imageSource
        }
        else if (color == "ColorYellow") {
            outerCircle.imageSource = "asset:///Squircle/squircleYellow.png"
            innerCircle.imageSource = outerCircle.imageSource
        }
        else if (color == "ColorTheme") {
            outerCircle.imageSource = isDarkTheme ? "asset:///Squircle/squircleWhite.png" : "asset:///Squircle/squircleBlack.png"
            innerCircle.imageSource = outerCircle.imageSource
        }
    }
    
    onRunningChanged: {
        if (running) {
            outerRotateTransition.play()
            parallelAnimation.play()
        }
        else {
            outerRotateTransition.stop()
            parallelAnimation.stop()
        }
    }
    
    onCreationCompleted: {
        outerRotateTransition.play()
        parallelAnimation.play()
    }
    
    layout: DockLayout {}
    ImageView {
        id: outerCircle
        scalingMethod: ScalingMethod.AspectFit
        preferredHeight: container.preferredHeight
        animations: [
            RotateTransition {
                id: outerRotateTransition
                fromAngleZ: rotationZ
                toAngleZ: rotationZ + 90
                duration: container.duration
                easingCurve: StockCurve.Linear
                onEnded: if (running) play()
            }
        ]
    }
    ImageView {
        id: innerCircle
        scalingMethod: ScalingMethod.AspectFit
        preferredHeight: container.preferredHeight
        animations: [
            ParallelAnimation {
                id: parallelAnimation
                onEnded: if (running) play()
                RotateTransition {
                    fromAngleZ: rotationZ
                    toAngleZ: rotationZ + 180
                    duration: container.duration
                    easingCurve: StockCurve.Linear
                }
                SequentialAnimation {
                    id: sequentialAnimation
                    ScaleTransition {
                        toX: 0.78
                        toY: toX
                        duration: container.duration / 2
                        easingCurve: StockCurve.Linear
                    }
                    ScaleTransition {
                        toX: 1
                        toY: toX
                        duration: container.duration / 2
                        easingCurve: StockCurve.Linear
                    }
                }
            }
        ]
    }
}
